from pytket._routing import Architecture, route
from pytket._circuit import OpType, optimise_pre_routing, optimise_post_routing

from qiskit import QuantumCircuit
from qiskit.converters import circuit_to_dag, dag_to_circuit

from pytket.qiskit import dagcircuit_to_tk, coupling_to_arc, tk_to_dagcircuit

# Rigetti 16Q Aspen
coupling_map = [(0, 1), (0, 7), (0, 15), (1, 2), (2, 3), (3, 4), (4, 5),
                (5, 6), (6, 7), (7, 8), (8, 9), (8, 15), (9, 10), (10, 11),
                (11, 12), (12, 13), (13, 14), (14, 15)]
directed_arc = coupling_to_arc(coupling_map)
qc = QuantumCircuit.from_qasm_file('Original0.qasm') # RuntimeError: 4
# qc = QuantumCircuit.from_qasm_file('Original1.qasm') # no error
dag = circuit_to_dag(qc)
tkcirc = dagcircuit_to_tk(dag)

print(tkcirc)
optimise_pre_routing(tkcirc)
outcirc, _ = route(tkcirc, directed_arc)
optimise_post_routing(outcirc)
print(outcirc)
